// Program Is UpLoad.c
// Sends EEPROM File To Prop1
// Last Revision On 25Feb20

#define CBR_230400 230400L
#define Limit  16

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stddef.h>
#include <time.h>
#include <math.h>
#include <process.h>

HANDLE hCom;

FILE *InPutFile;

char FileNameStr[80];

int GetChar(void)
{
 BOOL Status;
 DWORD BytesRead;
 char RxD[10];
 Status=ReadFile(hCom,RxD,1,&BytesRead,NULL);
 if(BytesRead < 1) return(-1);
 else return(RxD[0]);
}

char LoopBack(char OutPut)
{
 int Result;
 time_t TimeStart;
 time_t TimeStop;
 TransmitCommChar(hCom,OutPut);
 time(&TimeStart);
 for(;;)
  {
   time(&TimeStop);
   if(difftime(TimeStop,TimeStart) > 1.0) return(0);
   Result=GetChar();
   if(Result == OutPut) return(OutPut);
  }
 return(0);
}

char OutBack(char OutPut, char InPut)
{
 time_t TimeStart;
 time_t TimeStop;
 TransmitCommChar(hCom,OutPut);
 time(&TimeStart);
 for(;;)
  {
   time(&TimeStop);
   if(difftime(TimeStop,TimeStart) > 1.0) return(0);
   if(GetChar() == InPut) return(1);
  }
 return(0);
}

char FindComPort(void)
{
 char Index;
 char ComPort[20];
 DCB dcbSerialParams; 
 COMMTIMEOUTS timeouts; 
 COMMPROP comprop;
 dcbSerialParams.DCBlength = sizeof(dcbSerialParams); 
 for(Index=0; Index<10; Index++)
  {
   sprintf(ComPort,"COM%d",Index);
   hCom=CreateFile(ComPort,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
   if(hCom == INVALID_HANDLE_VALUE) continue;
   if(SetupComm(hCom, 1024, 1024) == FALSE) continue;
   if(GetCommProperties(hCom,&comprop) == FALSE) continue;
   if(GetCommState(hCom, &dcbSerialParams) == FALSE) continue; 
   dcbSerialParams.BaudRate = CBR_115200;
   dcbSerialParams.ByteSize = 8;
   dcbSerialParams.StopBits = ONESTOPBIT;
   dcbSerialParams.Parity = NOPARITY; 
   if(SetCommState(hCom, &dcbSerialParams) == FALSE) continue; 
   timeouts.ReadIntervalTimeout         = MAXDWORD;
   timeouts.ReadTotalTimeoutConstant    = 0;
   timeouts.ReadTotalTimeoutMultiplier  = 0;
   timeouts.WriteTotalTimeoutConstant   = 0;
   timeouts.WriteTotalTimeoutMultiplier = 0;
   if(SetCommTimeouts(hCom, &timeouts) == FALSE) continue;
   if(OutBack('?','P') > 0) break;
  }
 if(Index > 9) return('N');
 printf("Found On %s\n",ComPort);
 return('Y');
}

char Command(void)
{
 long MemAdd=0;
 long Value=0;
 char TempStr[80];
 char RxD;
 char Result;
 int  Index;
 int  InPutData;
 printf("Searching For Propeller...");
 if(FindComPort() == 'N') return('N');
 printf("Opening %s Data File\n",FileNameStr);
 InPutFile=fopen(FileNameStr,"rb");
 if(InPutFile == NULL) return('E');
 printf("Sending EEPROM Data To Propeller\n");
 for(;;)
  {
   sprintf(TempStr,"%.8X",MemAdd);
   if(LoopBack('M') == 0) return('T');
   for(Index=0; Index<8; Index++)
    {
     Result=LoopBack(TempStr[Index]);
     if(Result == 0) return('T');
     printf("%c",Result);
    }
   printf(" ");
   if(LoopBack('L') == 0) return('T');
   for(Value=0; Value<Limit; Value++)
    {
     InPutData=fgetc(InPutFile);
     switch(InPutData)
      {
       case EOF: fclose(InPutFile);
                 if(Value == 0) return('D');
                 if(LoopBack('W') == 0) return('T');
                 return('D');
                 break;
       default:  RxD=(char) InPutData;
                 sprintf(TempStr,"%.2X",RxD);
                 if(LoopBack(TempStr[0]) == 0) return('T');
                 if(LoopBack(TempStr[1]) == 0) return('T');
                 printf("%s ",TempStr);
                 break;
       }
    }
   if(LoopBack('W') == 0) return('T');
   printf("\r");
   MemAdd=MemAdd + Limit;
  }
 return('T');
}
 
void main(int argc, char *argv[])
{
 char Cmd;
 time_t TaskStart;
 time_t TaskStop;
 strcpy(FileNameStr,argv[1]);
 system("cls");
 time(&TaskStart);
 system("payload propload.binary");
 Cmd=Command();
 switch(Cmd)
  {
   case 'E': printf("\nError Opening EEPROM File\n");
             break;
   case 'N': printf("\nPropeller Not Found\n");
             CloseHandle(hCom);
             break;
   case 'D': printf("\nCompleted Sending EEPROM Data\n");
             time(&TaskStop);
             printf("Task Duration=%f Seconds\n",difftime(TaskStop,TaskStart)); 
             CloseHandle(hCom);
             break;
   case 'T': printf("\nTimeout Error Occurred\n");
             CloseHandle(hCom);
   default:  break;
  }
}





 